<?php

class PECL_Gen_Release extends PEAR
{
  /**
   * The current version number 
   *
   * @access private
   * @var     string
   */
  var $version = "0.0.7";
  
  /**
   * Set method for version number
   *
   * @access public
   * @param  string version
   * @return bool   true on success
   */
  function set_version($version) 
  {
    // TODO check format
    $this->version = $version;

    return true;
  }




  /**
   * The release date
   *
   * @access private
   * @var     string
   */
  var $date = "";
  
  /**
   * Set method for release date
   *
   * @access public
   * @param  int    timestamp
   * @return bool   true on success
   */
  function set_date($date)
  {
    // TODO parse date if not numeric
    // TODO check valid dates
    $this->date = $date;
    
    return true;
  }






  /**
   * The 'state': alpha, beta, stable, dev ...
   *
   * @access private
   * @var     string
   */
  var $state = "unkown";

  /**
   * Set method for state
   *
   * @access public
   * @param  string state
   * @return bool   true on success
   */
  function set_state($state)
  {
    // TODO check valid states
    $this->state = $state;
    
    return true;
  }




  /**
   * Release notes
   *
   * @access private
   * @var     string
   */
  var $notes = "";


  /**
   * Set method for release notes
   *
   * @access public
   * @param  string release notes
   * @return bool   true on success
   */
  function set_notes($notes)
  {
    $this->notes = $notes;

    return true;
  }





  /**
   * Constructor
   *
   * @access public
   */
  function __construct()
  {
    $this->date = date("Y-m-d");
  }
  



  /**
   * generate XML fragment for package.xml
   *
   * @access public
   * @return string XML fragment
   */
  function package_xml()
  {
    $code = "\n  <release>\n";
    foreach (array("version", "date", "state", "notes") as $key) {
      if ($this->$key !== "") {
        $code.= "    <$key>{$this->$key}</$key>\n";
      }
    }
    $code.= "  </release>\n";

    return $code;
  }

}

?>